/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"

GtkWidget*
create_mainwin (void)
{
  GtkWidget *mainwin;
  GtkWidget *vbox1;
  GtkWidget *filemenu;
  GtkWidget *item1;
  GtkWidget *item1_menu;
  GtkAccelGroup *item1_menu_accels;
  GtkWidget *gamequit;
  GtkWidget *frame1;
  GtkWidget *frame1_menu;
  GtkAccelGroup *frame1_menu_accels;
  GSList *frame_group = NULL;
  GtkWidget *f1_5;
  GtkWidget *f1_10;
  GtkWidget *f1_20;
  GtkWidget *bgm;
  GtkWidget *bgm_menu;
  GtkAccelGroup *bgm_menu_accels;
  GSList *bgm_group = NULL;
  GtkWidget *wave;
  GtkWidget *cd_da;
  GtkWidget *drawingarea1;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_widget_set_usize (mainwin, 640, -2);
  gtk_widget_set_events (mainwin, GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK | GDK_KEY_PRESS_MASK);
  gtk_window_set_title (GTK_WINDOW (mainwin), "'Urahara temptation' - limo reversi");
  gtk_window_set_policy (GTK_WINDOW (mainwin), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (mainwin), vbox1);

  filemenu = gtk_menu_bar_new ();
  gtk_widget_set_name (filemenu, "filemenu");
  gtk_widget_ref (filemenu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "filemenu", filemenu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (filemenu);
  gtk_box_pack_start (GTK_BOX (vbox1), filemenu, FALSE, FALSE, 0);
  gtk_menu_bar_set_shadow_type (GTK_MENU_BAR (filemenu), GTK_SHADOW_ETCHED_IN);

  item1 = gtk_menu_item_new_with_label ("File");
  gtk_widget_set_name (item1, "item1");
  gtk_widget_ref (item1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "item1", item1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (item1);
  gtk_container_add (GTK_CONTAINER (filemenu), item1);

  item1_menu = gtk_menu_new ();
  gtk_widget_set_name (item1_menu, "item1_menu");
  gtk_widget_ref (item1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "item1_menu", item1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (item1), item1_menu);
  item1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (item1_menu));

  gamequit = gtk_menu_item_new_with_label ("quit");
  gtk_widget_set_name (gamequit, "gamequit");
  gtk_widget_ref (gamequit);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "gamequit", gamequit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (gamequit);
  gtk_container_add (GTK_CONTAINER (item1_menu), gamequit);
  gtk_widget_add_accelerator (gamequit, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  frame1 = gtk_menu_item_new_with_label ("Speed");
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (filemenu), frame1);

  frame1_menu = gtk_menu_new ();
  gtk_widget_set_name (frame1_menu, "frame1_menu");
  gtk_widget_ref (frame1_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "frame1_menu", frame1_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (frame1), frame1_menu);
  frame1_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (frame1_menu));

  f1_5 = gtk_radio_menu_item_new_with_label (frame_group, "5 frame/sec");
  frame_group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (f1_5));
  gtk_widget_set_name (f1_5, "f1_5");
  gtk_widget_ref (f1_5);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_5", f1_5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_5);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_5);

  f1_10 = gtk_radio_menu_item_new_with_label (frame_group, "10 frame/sec");
  frame_group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (f1_10));
  gtk_widget_set_name (f1_10, "f1_10");
  gtk_widget_ref (f1_10);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_10", f1_10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_10);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_10);

  f1_20 = gtk_radio_menu_item_new_with_label (frame_group, "20 frame/sec");
  frame_group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (f1_20));
  gtk_widget_set_name (f1_20, "f1_20");
  gtk_widget_ref (f1_20);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "f1_20", f1_20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (f1_20);
  gtk_container_add (GTK_CONTAINER (frame1_menu), f1_20);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (f1_20), TRUE);

  bgm = gtk_menu_item_new_with_label ("BGM");
  gtk_widget_set_name (bgm, "bgm");
  gtk_widget_ref (bgm);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "bgm", bgm,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (bgm);
  gtk_container_add (GTK_CONTAINER (filemenu), bgm);

  bgm_menu = gtk_menu_new ();
  gtk_widget_set_name (bgm_menu, "bgm_menu");
  gtk_widget_ref (bgm_menu);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "bgm_menu", bgm_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (bgm), bgm_menu);
  bgm_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (bgm_menu));

  wave = gtk_radio_menu_item_new_with_label (bgm_group, "PCM");
  bgm_group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (wave));
  gtk_widget_set_name (wave, "wave");
  gtk_widget_ref (wave);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "wave", wave,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wave);
  gtk_container_add (GTK_CONTAINER (bgm_menu), wave);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (wave), TRUE);

  cd_da = gtk_radio_menu_item_new_with_label (bgm_group, "CD-DA");
  bgm_group = gtk_radio_menu_item_group (GTK_RADIO_MENU_ITEM (cd_da));
  gtk_widget_set_name (cd_da, "cd_da");
  gtk_widget_ref (cd_da);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "cd_da", cd_da,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cd_da);
  gtk_container_add (GTK_CONTAINER (bgm_menu), cd_da);

  drawingarea1 = gtk_drawing_area_new ();
  gtk_widget_set_name (drawingarea1, "drawingarea1");
  gtk_widget_ref (drawingarea1);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "drawingarea1", drawingarea1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea1);
  gtk_box_pack_start (GTK_BOX (vbox1), drawingarea1, TRUE, TRUE, 0);
  gtk_widget_set_usize (drawingarea1, 640, 480);
  gtk_widget_set_events (drawingarea1, GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (item1), "activate",
                      GTK_SIGNAL_FUNC (on_item1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (gamequit), "activate",
                      GTK_SIGNAL_FUNC (on_gamequit_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (frame1), "activate",
                      GTK_SIGNAL_FUNC (on_frame1_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_5), "activate",
                      GTK_SIGNAL_FUNC (on_f1_5_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_10), "activate",
                      GTK_SIGNAL_FUNC (on_f1_10_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (f1_20), "activate",
                      GTK_SIGNAL_FUNC (on_f1_20_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (wave), "activate",
                      GTK_SIGNAL_FUNC (on_wave_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cd_da), "activate",
                      GTK_SIGNAL_FUNC (on_cd_da_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea1), "expose_event",
                      GTK_SIGNAL_FUNC (on_drawingarea1_expose_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea1), "button_press_event",
                      GTK_SIGNAL_FUNC (on_drawingarea1_button_press_event),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (mainwin), accel_group);

  return mainwin;
}

