/* =====================================================================

   LiMo - Liblary
      Input System.  - ϥ󥿡ե

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Dec.04.1999  Programing start (Reversi)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRInputInit            -- ʤˤʤ
  RRInputSignalKey       -- ܡϥʥդ
  RRInputSignalPress     -- ޥܥ󥷥ʥդ
  RRInputFlashKey        -- ϥǡΥꥢ
  RRInputFlashClick      -- åǡΥꥢ
  RRInputKey             -- ϤηϤ
  RRInputClick           -- åηϤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <gtk/gtk.h>
#include  "rr_screen.h"
#include  "rr_input.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -- ϥ塼ξ */
#define  CUEMAX  32

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- оݥɥ */
static GtkWidget  *screen;

/* --- ϥǡ */
static gint key_num, key_ptr;
static gchar key_data[CUEMAX];

/* --- åǡ */
static gint click_num, click_ptr;
static RRClick click_data[CUEMAX];

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRInputInit       -- ʤ

   return : void
   GtkWidget *screen Ϥդ륹꡼

-------------------------------------------------------------- */
void RRInputInit(GtkWidget *win)
{
  screen = win;
  key_num = key_ptr = 0;
  click_num = click_ptr = 0;
}


/* -------------------------------------------------------------
  RRInputSignalKey       -- ܡϥʥդ

   return : void
   ʥ

-------------------------------------------------------------- */
gboolean   RRInputSignalKey(GtkWidget       *widget,
			    GdkEventKey     *event,
			    gpointer         user_data)
{
  guint key;
  gchar *keytop;

  if (widget == screen) {
    if (key_num < CUEMAX) {
      key = gdk_keyval_to_lower(event->keyval);
      keytop = gdk_keyval_name(key);
      key_data[key_ptr] = keytop[0];
      key_ptr = (key_ptr + 1) % CUEMAX;
      key_num++;
    }
  }

  return FALSE;
}


/* -------------------------------------------------------------
  RRInputSignalPress     -- ޥܥ󥷥ʥդ

   return : void
   ʥ

-------------------------------------------------------------- */
gboolean   RRInputSignalPress(GtkWidget       *widget,
			      GdkEventButton  *event,
			      gpointer         user_data)
{
  GdkEventButton *event_button;
  gint  x, y;

  if (widget == screen) {
    if (event->type == GDK_BUTTON_PRESS) {
      event_button = (GdkEventButton *) event;
      if (event_button->button == 1) {
	if (click_num < CUEMAX) {
	  gtk_widget_get_pointer(screen, &x, &y); 
	  click_data[click_ptr].x = x;
	  click_data[click_ptr].y = y;
	  click_ptr = (click_ptr + 1) % CUEMAX;
	  click_num++;
	}
	return TRUE;
      }
    }
  }
  return FALSE;
}


/* -------------------------------------------------------------
  RRInputFlashKey        -- ϥǡΥꥢ

   return : void
   ʥ

-------------------------------------------------------------- */
void       RRInputFlashKey(void)
{
  key_num = 0;
}


/* -------------------------------------------------------------
  RRInputFlashClick      -- åǡΥꥢ

   return : void
   ʥ

-------------------------------------------------------------- */
void       RRInputFlashClick(void)
{
  click_num = 0;
}


/* -------------------------------------------------------------
  RRInputKey             -- ϤηϤ

   return : void
   gchar Ϥ줿饯(ʸ) NULL ʤ̵

-------------------------------------------------------------- */
gchar      RRInputKey(void)
{
  gchar  r;
  if (key_num == 0) return(0);
  r = key_data[((key_ptr+CUEMAX-key_num)%CUEMAX)];
  key_num--;
  return(r);
}


/* -------------------------------------------------------------
  RRInputClick           -- åηϤ

   return : void
   ʥ

-------------------------------------------------------------- */
RRClick   *RRInputClick(void)
{
  RRClick *r;
  if (click_num == 0) return(NULL);
  r = &click_data[((click_ptr+CUEMAX-click_num)%CUEMAX)];
  click_num--;
  return(r);
}

