/* =====================================================================

   LiMo Reversi 
      Animation sequence.  - ˥᡼󥷡

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jun.11.2000  Programing start

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVAnimInit         -- 
  RVAnimRequest      -- ˥᡼
  RVAnimDataSet      -- ˥᡼ǡ
  RVAnimSequence     -- ˥᡼󥷡

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "rr_main.h"
#include "rv_data.h"



/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- ˥᡼Υѥ */
#define  ANIM_MAX  8


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  read_seq(void);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* ----- ˥᡼ǡΥե졼 */
gint  anim_frame_max[ANIM_MAX];
unsigned char  *seq_top[ANIM_MAX];

/* ----- ơǡ */
unsigned char  *stage_scr;

/* ----- 󥹥ޡ */
gint  anim_num;
gint  frame_timer;
gint  frame_count;
gint  frame_number;
gint  local_timer;
gboolean  anim_halt;

/* ----- 󥹥ݥ󥿡 */
unsigned char  *seq_ptr;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RVAnimInit       -- 

   return : void
   void

-------------------------------------------------------------- */
void  RVAnimInit(void)
{
  anim_num = -1;
}


/* -------------------------------------------------------------
  RVAnimRequest     -- ˥᡼

   return : void
   gint  num ˥᡼ʥС

-------------------------------------------------------------- */
void  RVAnimRequest(gint num)
{
  if ((num < 0) || (num > ANIM_MAX)) {
    return;
  }
  anim_num = num;
  seq_ptr = seq_top[num];
  frame_timer = 0;
  frame_count = 0;
  local_timer = 0;
  anim_halt = FALSE;
  read_seq();
}


/* -------------------------------------------------------------
  RVAnimDataSet    -- ˥᡼ǡ

   return : void
   unsigned char *data  ơǡ
   unsigned char *start 󥹥ȥåץɥ쥹
   gint  num ˥᡼ʥС
   gint  fr  ˥᡼ե졼

-------------------------------------------------------------- */
void  RVAnimDataSet(unsigned char *data, unsigned char *start,
		    gint num, gint fr)
{
  if ((num < 0) || (num > ANIM_MAX)) {
    return;
  }
  stage_scr = data;  
  seq_top[num] = start;
  anim_frame_max[num] = fr;
}


/* -------------------------------------------------------------
  RVAnimSequence     -- ˥᡼󥷡

   return : gint ɽ٤
   void

-------------------------------------------------------------- */
gint  RVAnimSequence(void)
{
  gint  t;

  if (anim_halt == FALSE) {
    local_timer++;
    t = local_timer * 20 / RRMainIntervalTime();

    if (t > frame_timer) {
      if (anim_num != -1) {
	read_seq();
      }
      local_timer = 0;
    }
  }

  return(frame_number);
}


/*=================================================================*/
/*  ʥ֥롼                                         */
/*=================================================================*/

/* -------------------------------------------------------------
  read_seq    -- 󥹤鼡ΰ쥳ɤ߹
  ---------------------------------------------------------------*/
void  read_seq(void)
{
  unsigned char  line[256];
  gint  i, l;

  if (frame_count == anim_frame_max[anim_num]) {
    seq_ptr = seq_top[anim_num];
    frame_count = 0;
  }
  /* --- ȴ */
  l = 0;
  for(i=0; i<256; i++) {
    /* ԥɷǤä */
    if (seq_ptr[i] == 0x0a) {
      line[l] = '\0';
      seq_ptr += (l+1);
      break;
    }
    else {
      line[l] = seq_ptr[i];
    }
    l++;
  }
  sscanf(line, "%d %d", &frame_number, &frame_timer);
  if (frame_timer == 0) {
    anim_halt = TRUE;
  }
  frame_count++;
}
