/* =====================================================================

   LiMo Reversi 
      Board Manage.  - פδ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */


/* -------------------------------------------------------------
 --- History

  Nov.23.1999  Programing start
  Aug.20.2000  MINABE Oki <minabe@kitanet.ne.jp> ɲôؿ
               
               RVBoardMiniAbleFast(gint, gint, gint*);
               RVBoardMiniCountAble(gint, gint*, gint*);
               RVBoardMiniReverse(gint, gint, gint*);
               do_reverse_mini(gint, gint, gint, gint*);

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVBoardInit          -- Ƽ
  RVBoardKoma          -- ζ󥲥å
  RVBoardKomaAnim      -- 򥢥˥᡼󤵤
  RVBoardKomaAnimStat  -- 𥢥˥椫ɤ
  RVBoardCheckPass     -- Ǥļ̵ɤ
  RVBoardAbleToPut     -- ֤뤫ɤȽ
  RVBoardPutKoma       -- ֤(֤˥ᥳ)
  RVBoardReverseKoma   -- ֤(Ҥä֤ꥢ˥ᥳ)
  RVBoardMini          -- ̾ܡɥǡϤ(׹ͥ롼)
  RVBoardMiniAble      -- ̾ܡ֤뤫ɤȽ(׹ͥ롼)
  RVBoardMiniAbleFast  -- ̾ܡ֤뤫ɤȽ礤ᤤ
  RVBoardMiniCountAble -- ֤꤬սꤢ뤫ο夲
  RVBoardMiniReverse   -- ̾ܡǼºݤˤҤä֤Ƥߤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <gtk/gtk.h>
#include "rr_screen.h"
#include "rr_main.h"
#include "rv_board.h"
#include "rv_display.h"
#include "rv_data.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -- Ϣ³ƤҤä֤Υ˥ٱ */
#define KOMA_DELAY  5
#define DIR_DELAY   10

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

gint  reverse_check(gint , gint , gint);
void  do_reverse(gint, gint, gint, gint);
gint  reverse_check_mini(gint, gint, gint, gint*);
gint  do_reverse_mini(gint, gint, gint, gint*);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ׾ζ */
RVKoma   game_board[64];

/* --- 뤫ɤξ󥭥å :-) */
gint     put_cache[64];
gint     side_cache;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RVBoardInit       -- 

   return : void
   void

-------------------------------------------------------------- */
void  RVBoardInit(void)
{
  gint  i;

  for(i=0; i<64; i++) {
    game_board[i].stat = 0;
    game_board[i].anim_wait = 0;
    game_board[i].anim_num = 0;
    game_board[i].anim_timer = 0;
    game_board[i].anim_flag = FALSE;
    game_board[i].update = TRUE;
  }
  game_board[27].stat = 1;
  game_board[28].stat = 2;
  game_board[35].stat = 2;
  game_board[36].stat = 1;
  side_cache = 0;
}


/* -------------------------------------------------------------
  RVBoardKoma         -- ζ󥲥å

   return : void
   void

-------------------------------------------------------------- */
RVKoma *RVBoardKoma(gint n)
{
  return(&game_board[n]);
}


/* -------------------------------------------------------------
  RVBoardKomaAnim       -- 򥢥˥᡼󤵤

   return : void
   void

-------------------------------------------------------------- */
void  RVBoardKomaAnim(void)
{
  int  i;

  for(i=0; i<64; i++) {
    if (game_board[i].anim_flag == TRUE) {
      if (game_board[i].anim_wait > 0) {
	/* -- ʤ鼡Ԥä㤦 */
	game_board[i].anim_wait--;
	if ((game_board[i].anim_wait == 0) && (game_board[i].anim_num < 2)) {
	  RVDataSoundRequest("S ON 1 4 200 200");
	}
	continue;
      }
      if (game_board[i].anim_timer == 0) {
	/* -- ˥Ὢλ */
	switch(game_board[i].anim_num) {
	case 0:
	  game_board[i].stat = 2;
	  break;
	case 1:
	  game_board[i].stat = 1;
	  break;
	case 2:
	  game_board[i].stat = 1;
	  break;
	case 3:
	  game_board[i].stat = 2;
	  break;
	}
	game_board[i].update = TRUE;
	game_board[i].anim_flag = FALSE;
      }
      else {
	/* -- ˥ */
	switch(RRMainIntervalTime()){
	case 5:
	  game_board[i].anim_timer-=2;
	case 10:
	  game_board[i].anim_timer--;
	case 20:
	  game_board[i].anim_timer--;
	}
	if (game_board[i].anim_timer < 0) {
	  game_board[i].anim_timer = 0;
	}
      }
    }
  }
}


/* -------------------------------------------------------------
  RVBoardKomaAnimStat      -- 𥢥˥椫ɤ

   return : gboolean (˥椫ɤΥե饰 true=˥)
   void

-------------------------------------------------------------- */
gboolean  RVBoardKomaAnimStat(void)
{
  gboolean  r;
  int  i;

  r = FALSE;
  for(i=0; i<64; i++) {
    if (game_board[i].anim_flag == TRUE) {
      r = TRUE;
    }
  }

  return(r);
}


/* -------------------------------------------------------------
  RVBoardCheckPass    -- Ǥļ̵ɤ

   return : gboolean (ѥɤ true=Ǥļ̵)
   gint  side(֤ 1=red, 2=white)

-------------------------------------------------------------- */
gboolean  RVBoardCheckPass(gint side)
{
  gint i, j, r;
  gboolean check;
  
  check = TRUE;
  for(i=0; i<64; i++) {
    if (game_board[i].stat == 0) {
      r = 0;
      for(j=0; j<8; j++) {
	r += reverse_check(side, i, j);
      }
      put_cache[i] = r;
      if (r > 0) check = FALSE;
    }
  }
  side_cache = side;

  return(check);
}


/* -------------------------------------------------------------
  RVBoardAbleToPut    -- ֤뤫ɤȽ

   return : gint (Ķ𤬼뤫 0=֤ޤ)
   gint  side(֤), pos(Ĵ٤)

-------------------------------------------------------------- */
gint  RVBoardAbleToPut(gint side, gint pos)
{
  if (game_board[pos].stat != 0) return(0);
  if (side_cache != side) {
    if (RVBoardCheckPass(side) == TRUE) return(0);
  }
  return(put_cache[pos]);
}


/* -------------------------------------------------------------
  RVBoardPutKoma      -- ֤(֤˥ᥳ)

   return : void
   gint  side(֤), pos(֤)

-------------------------------------------------------------- */
void  RVBoardPutKoma(gint side, gint pos)
{
  game_board[pos].anim_flag = TRUE;
  game_board[pos].anim_wait = 0;
  /* ANIME_TIME default ٤ (^^;  */
  game_board[pos].anim_timer = ANIME_TIME / 3;
  /* anim_num = (side+1); Ǥɤ뤬 */
  RVDataSoundRequest("S ON 0 3 255 255");
  if (side == 1) {
    game_board[pos].anim_num = 2;
  }
  else {
    game_board[pos].anim_num = 3;
  }
}


/* -------------------------------------------------------------
  RVBoardReverseKoma      -- ֤(Ҥä֤ꥢ˥ᥳ)

   return : ĤϤ
   gint  side(֤), pos(֤)

-------------------------------------------------------------- */
gint  RVBoardReverseKoma(gint side, gint pos)
{
  gint  i, w, g, total;

  total = w = 0;
  for(i=0; i<8; i++) {
    if ((g = reverse_check(side, pos, i)) > 0) {
      do_reverse(side, pos, i, w);
      w += (DIR_DELAY * RRMainIntervalTime() / 20);
      total += g;
    }
  }
  return(total);
}


/* -------------------------------------------------------------
  RVBoardMini         -- ̾ܡɥǡϤ(׹ͥ롼)

   return : void
   gint  *board(̾ܡɥǡؤΥݥ,)

-------------------------------------------------------------- */
void  RVBoardMini(gint *board)
{
  gint i;

  for(i=0; i<64; i++) {
    board[i] = game_board[i].stat;
  }
}


/* -------------------------------------------------------------
  RVBoardMiniAble     -- ̾ܡ֤뤫ɤȽ(׹ͥ롼)

   return : gint (֤鲿Ķ𤬼뤫 0=֤ޤ)
   gint  side(֤), pos(), *board(̾ܡɥǡΥݥ)

-------------------------------------------------------------- */
gint  RVBoardMiniAble(gint side, gint pos, gint *board)
{
  gint  i, r;

  r = 0;
  for(i=0; i<8; i++) {
    r += reverse_check_mini(side, pos, i, board);
  }
  return(r);
}



/* -------------------------------------------------------------
  RVBoardMiniAbleFast  -- ̾ܡ֤뤫ɤȽ礤ᤤ

   return : gint (1=֤ 0=֤ʤ)
   gint  side(֤), pos(), *board(̾ܡɥǡΥݥ)

   RVBoardMiniAble() $H0c$C$F2?8D<h$l$k$+$r?t$($J$$

-------------------------------------------------------------- */
gint  RVBoardMiniAbleFast(gint side, gint pos, gint *board)
{
  const gint start[64] = {
    6, 6, 4, 4, 4, 4, 4, 4,
    6, 6, 4, 4, 4, 4, 4, 4,
    6, 6, 0, 0, 0, 0, 2, 2,
    6, 6, 0, 0, 0, 0, 2, 2,
    6, 6, 0, 0, 0, 0, 2, 2,
    6, 6, 0, 0, 0, 0, 2, 2,
    0, 0, 0, 0, 0, 0, 2, 2,
    0, 0, 0, 0, 0, 0, 2, 2
  };
  const gint   end[64] = {
    1, 1, 1, 1, 1, 1, 7, 7,
    1, 1, 1, 1, 1, 1, 7, 7,
    3, 3, 0, 0, 0, 0, 7, 7,
    3, 3, 0, 0, 0, 0, 7, 7,
    3, 3, 0, 0, 0, 0, 7, 7,
    3, 3, 0, 0, 0, 0, 7, 7,
    3, 3, 5, 5, 5, 5, 5, 5,
    3, 3, 5, 5, 5, 5, 5, 5
  };
  gint  i;
  i = start[pos];

  while (1) {
    if (reverse_check_mini(side, pos, i, board) > 0) {
      return(1);
    }
    if ((i = (i+1) & 7) == end[pos]) break;
  }
  return(0);
}


/* -------------------------------------------------------------
  RVBoardMiniCountAble -- ֤꤬սꤢ뤫ο夲

   return : gint
   gint  side, *board, *flag

-------------------------------------------------------------- */
gint  RVBoardMiniCountAble(gint side, gint *board, gint *flag)
{
  gint i, count = 0, n = 0;
  for(i=0; i<64; i++) {
    if (board[i] == 0 && RVBoardMiniAbleFast(side, i, board) > 0) {
      flag[n++] = i;
      count++;
    }
  }
  flag[n] = -1;
  return count;
}


/* -------------------------------------------------------------
  RVBoardMiniReverse   -- ̾ܡǼºݤˤҤä֤Ƥߤ

   return : gint (Ҥä֤äޤο)
   gint  side, pos, *board

-------------------------------------------------------------- */
gint  RVBoardMiniReverse(gint side, gint pos, gint *board)
{
  gint  i, r, t;

  r = 0;
  for(i=0; i<8; i++) {
    if ((t = do_reverse_mini(side, pos, i, board)) > 0) {
      r += t;
    }
  }
  if (r != 0) {
    board[pos] = side;
  }
  return(r);
}




/* -------------------------------------------------------------
   --- ֤뤫ɤδϢ֥롼
-------------------------------------------------------------- */
/* -------------------------------------------------------------
  reverse_check    -- Ϥ뤫ɤ

   return : gint (Ķ𤬼뤫 0=Ϥޤ)
   gint  side(֤), pos(Ĵ٤), dir( 08)

-------------------------------------------------------------- */
gint  reverse_check(gint side, gint pos, gint dir)
{
  const gint dir_x[8] = {1, 1, 0, -1, -1, -1, 0, 1};
  const gint dir_y[8] = {0, -1, -1, -1, 0, 1, 1, 1};
  gint  px, py, sand, link;

  /* --- Ĵ٤٤ */
  px = pos % 8;
  py = pos / 8;
  sand = link = 0;

  /* --- Ĵ٤ޤ礦 */
  px += dir_x[dir];
  py += dir_y[dir];
  while((px >= 0) && (px < 8) && (py >= 0) && (py < 8)) {
    if (game_board[px+(py*8)].stat == side) {
      sand = link;
      break;
    } 
    else if (game_board[px+(py*8)].stat == 0) {
      break;
    }
    else {
      link++;
    }
    px += dir_x[dir];
    py += dir_y[dir];
  } 
  return(sand);
}


/* -------------------------------------------------------------
  do_reverse     -- ϤǤҤä֤ޤ

   return : void
   gint  side(֤), pos(֤), dir( 08), wait(wait)

-------------------------------------------------------------- */
void  do_reverse(gint side, gint pos, gint dir, gint wait)
{
  const gint dir_x[8] = {1, 1, 0, -1, -1, -1, 0, 1};
  const gint dir_y[8] = {0, -1, -1, -1, 0, 1, 1, 1};
  gint  px, py;
  gint  wtime;

  /* --- Ĵ٤٤ */
  px = pos % 8;
  py = pos / 8;
  wtime = wait;

  /* --- Ҥä֤ޤ礦 */
  px += dir_x[dir];
  py += dir_y[dir];
  while((px >= 0) && (px < 8) && (py >= 0) && (py < 8)) {
    if (game_board[px+(py*8)].stat == side) {
      break;
    } 
    else if (game_board[px+(py*8)].stat == 0) {
      break;
    }
    else {
      game_board[px+(py*8)].anim_flag = TRUE;
      game_board[px+(py*8)].anim_wait = wtime+1;
      game_board[px+(py*8)].anim_timer = ANIME_TIME;
      /* anim_num = (side-1)^1; Ǥɤ뤬 */
      if (side == 1) {
	game_board[px+(py*8)].anim_num = 1;
      }
      else {
	game_board[px+(py*8)].anim_num = 0;
      }
      wtime += (KOMA_DELAY * RRMainIntervalTime() / 20);
    }
    px += dir_x[dir];
    py += dir_y[dir];
  } 
}


/* -------------------------------------------------------------
  reverse_check_mini    -- Ϥ뤫ɤ(׹ͥ롼)

   return : gint (Ķ𤬼뤫 0=Ϥޤ)
   gint  side(֤), pos(Ĵ٤), dir( 08), *board

-------------------------------------------------------------- */
gint  reverse_check_mini(gint side, gint pos, gint dir, gint *board)
{
  const gint dir_x[8] = {1, 1, 0, -1, -1, -1, 0, 1};
  const gint dir_y[8] = {0, -1, -1, -1, 0, 1, 1, 1};
  gint  px, py, sand, link;

  /* --- Ĵ٤٤ */
  px = pos % 8;
  py = pos / 8;
  sand = link = 0;

  /* --- Ĵ٤ޤ礦 */
  px += dir_x[dir];
  py += dir_y[dir];
  while((px >= 0) && (px < 8) && (py >= 0) && (py < 8)) {
    if (board[px+(py*8)] == side) {
      sand = link;
      break;
    } 
    else if (board[px+(py*8)] == 0) {
      break;
    }
    else {
      link++;
    }
    px += dir_x[dir];
    py += dir_y[dir];
  } 
  return(sand);
}


/* -------------------------------------------------------------
  do_reverse_mini    -- ºݤˤҤä֤Ƥߤ

   return : gint (Ҥä֤Υޤο)
   gint  side, pos, dir, *board

-------------------------------------------------------------- */
gint  do_reverse_mini(gint side, gint pos, gint dir, gint *board)
{
  const gint dir_x[8] = {1, 1, 0, -1, -1, -1, 0, 1};
  const gint dir_y[8] = {0, -1, -1, -1, 0, 1, 1, 1};
  gint  px, py;
  gint  turn_pos[8], i, n, flag;

  flag = n = 0;
  turn_pos[n] = -1;
 
  /* --- ޤ򤪤 */
  px = pos % 8;
  py = pos / 8;

  /* --- Ĵ٤ޤ礦 */
  px += dir_x[dir];
  py += dir_y[dir];
  while((px >= 0) && (px < 8) && (py >= 0) && (py < 8)) {
    if (board[px+(py*8)] == side) {
      flag = 1;
      break;
    }
    else if (board[px+(py*8)] == 0) {
      break;
    }
    else {
      turn_pos[n++] = px+(py*8);
    }
    px += dir_x[dir];
    py += dir_y[dir];
  }
  if (flag == 1) {
    for (i=0; i<n; i++) {
      board[turn_pos[i]] = side;
    }
  }
  return n;
}
