/* =====================================================================

   LiMo Reversi 
      GameSystem Main.  - ץꥱ٥ᥤ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Nov.23.1999  Programing start
  Feb.28.2001  ȥ륳ܥɲ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RVMainInit          -- ᥤץʤ
  RVMainFree          -- ᥤλ
  RVMain              -- ֤˥뤵ᥤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <gtk/gtk.h>
#include "rr_main.h"
#include "rv_main.h"
#include "rv_display.h"
#include "rv_game.h"
#include "rv_title.h"
#include "rv_data.h"
#include "rv_break.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- ƥåץ٥ */
enum {
  ST_NULL = 0,
  ST_INIT,
  ST_INFO_INIT,
  ST_INFO,
  ST_INFO_AFTER,
  ST_TITLE_INIT,
  ST_TITLE_CALL,
  ST_TITLE,
  ST_TITLE_AFTER,
  ST_GAME_I,
  ST_GAME,
  ST_CONTINUE_I,
  ST_CONTINUE,
  ST_GAMEOVER_I,
  ST_GAMEOVER,
  ST_BREAK_I,
  ST_BREAK,
  ST_ENDING,
  ST_ENDING_I,
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ʤȤʤƤ */
static gint  localtimer;
static gint  timer;

/* --- ץʹԥƥå */
static gint  rv_main_step;

/* --- ॹơʹ */
static gint  rv_main_stage;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RVMainInit       -- ᥤʤ(ॳɥ)

   return : void
   void

-------------------------------------------------------------- */
void  RVMainInit(void)
{
  localtimer = 0;
  rv_main_step =ST_INIT;

  /* --- ǡν */
  RVDataInit();

}


/* -------------------------------------------------------------
  RVMainFree       -- λ

   return : void
   void

-------------------------------------------------------------- */
void  RVMainFree(void)
{
  /* --- ǡθ */
  RVDataFree();
}


/* -------------------------------------------------------------
  RVMain       -- ץꥱ٥ᥤ

   return : void
   void

-------------------------------------------------------------- */
void  RVMain(void)
{
  gint  ret;

  localtimer++;

  /* -----------------------------------------------
     ॹƥå׽
   ------------------------------------------------ */
  switch(rv_main_step) {
  case ST_INIT:
    /* -- ץꥱ */
    rv_main_step = ST_INFO_INIT;
    break;

  case ST_INFO_INIT:
    /* -- ̾ɽ */
    RVTitleCircleInit();
    rv_main_step = ST_INFO;
    break;

  case ST_INFO:
    /* -- ̾åʤ */
    if (RVTitleCircleMain() == 0) {
      timer = 20 / (20 / RRMainIntervalTime());
      rv_main_step = ST_INFO_AFTER;
    }
    break;

  case ST_INFO_AFTER:
    /* -- äȤɽ; */
    timer--;
    if (timer <= 0) {
      rv_main_step = ST_TITLE_INIT;
    }
    break;

  case ST_TITLE_INIT:
    /* -- ȥ̽ */
    RVTitleTitleInit();
    RVDataSoundRequest("S ON 0 20 255 255");
    timer = 30;
    rv_main_step = ST_TITLE_CALL;
    break;

  case ST_TITLE_CALL:
    /* -- ȥ륳ܥ */
    timer--;
    if (timer <= 0) {
      rv_main_step = ST_TITLE;
      RVDataBGMRequest(2);
    }
    break;

  case ST_TITLE:
    /* -- åƤ */
    timer++;
    if ((timer % RRMainIntervalTime()) == 0) {
      RVTitleTitleAnim();
    }
    /* -- ȥɽ */
    if (RVTitleTitleMain() == 0) {
      timer = 20 / (20 / RRMainIntervalTime());
      rv_main_step = ST_TITLE_AFTER;
    }
    break;

  case ST_TITLE_AFTER:
    /* -- ॹ;(󥰥Ĥ餹) */
    timer--;
    RVTitleTitleAnim();
    if (timer <= 0) {
      RVTitleTitleFree();
      rv_main_stage = 0;
      rv_main_step = ST_GAME_I;
    }
    break;

  case ST_GAME_I:
    /* --  */
    RVGameInit(rv_main_stage);
    rv_main_step = ST_GAME;

  case ST_GAME:
    /* --  */
    RVGameMain();
    if ((ret = RVGameStat()) != GAME_DOING) {
      /* - 1ཪäΤǼ */
      switch(ret) {
      case GAME_P_WIN:
	rv_main_step = ST_BREAK_I;
	break;
      case GAME_P_LOSE:
      case GAME_DRAW:
	rv_main_step = ST_CONTINUE_I;
      default:
	rv_main_step = ST_CONTINUE_I;
      }
    }
    break;

  case ST_CONTINUE_I:
    RVTitleContInit();
    rv_main_step = ST_CONTINUE;
    break;

  case ST_CONTINUE:
    if ((ret = RVTitleContMain()) != 1) {
      RVTitleContFree();
      if (ret == 2) {
	rv_main_step = ST_GAME_I;
      }
      else {
	rv_main_step = ST_GAMEOVER_I;
      }
    }
    break;

  case ST_BREAK_I:
    RVBreakInit();
    rv_main_step = ST_BREAK;
    break;

  case ST_BREAK:
    if ((ret = RVBreakMain()) != 1) {
      RVBreakFree();
      rv_main_stage++;
      if (rv_main_stage >= RVDataStageNum()) {
	rv_main_step = ST_ENDING_I;
      }
      else {
	rv_main_step = ST_GAME_I;
      }
    }
    break;

  case ST_GAMEOVER_I:
    RVTitleGmovInit();
    rv_main_step = ST_GAMEOVER;
    break;

  case ST_GAMEOVER:
    if ((ret = RVTitleGmovMain()) != 1) {
      RVTitleGmovFree();
      rv_main_step = ST_INFO_INIT;
    }
    break;

  case ST_ENDING_I:
    RVTitleClearInit();
    rv_main_step = ST_ENDING;
    break;

  case ST_ENDING:
    if ((ret = RVTitleClearMain()) != 1) {
      RVTitleClearFree();
      rv_main_step = ST_INFO_INIT;
    }
    break;

  default:

  }
}



